/******************************************************************************
 * shadow.h 
 * implements the base shadow class
 * Copyright (C) 2010 Marc Gissler <gisslerm@informatik.uni-freiburg.de>
 ******************************************************************************/

#ifndef SHADOW_H
#define SHADOW_H

#include "globals.h"
#include "mesh.h"

#include <vector>
#include <map>

#include "gmMath\gmVec3.h"
#include "gmMath\gmVec4.h"

// ----------------------------------------
// misc stuff
//

class CShadowData
{
public:
};

// ------------------------------------------------------------
// defines thes shadow class
// 

class CShadow 
{
public:
	// constructor/destructor
	CShadow();
	~CShadow();

	// preprocess all necessary data
	virtual void build(int lightId, gmVector3& lightPos) = 0;

	static CShadow* instantiateShadow(std::string strMethod);

	virtual void clear() = 0;

	// draws the scene with shadows
	virtual void drawSceneWithShadows() = 0;

	// member variables
protected:

	std::map<int, CShadowData*> m_mapLightAndData;

};

#endif
